## typefind typefind — Finds the media type of a stream |

## Synopsis

    struct              GstTypeFindElement;

## Object Hierarchy

      GObject
       +----GInitiallyUnowned
             +----GstObject
                   +----GstElement
                         +----GstTypeFindElement

## Properties

      "caps"                     GstCaps*              : Read
      "force-caps"               GstCaps*              : Read / Write
      "minimum"                  guint                 : Read / Write

## Signals

      "have-type"                                      : Run First

## Description

Determines the media-type of a stream. It applies typefind functions in the order of their rank. One the type has been deteted it sets its src pad caps to the found media type.

Whenever a type is found the "have-type" signal is emitted, either from the streaming thread or the application thread (the latter may happen when typefinding is done pull-based from the state change function).

Plugins can register custom typefinders by using GstTypeFindFactory.

## Synopsis

### Element Information

plugin | coreelements
author | Benjamin Otte <in7y118@public.uni-hamburg.de>
class | Generic

### Element Pads

name | sink
direction | sink
presence | always
details | ANY

name | src
direction | source
presence | always
details | ANY

## Details

### struct GstTypeFindElement

    struct GstTypeFindElement;

Opaque GstTypeFindElement data structure

## Property Details

### The `"caps"` property

      "caps"                     GstCaps*              : Read

detected capabilities in stream.

### The `"force-caps"` property

      "force-caps"               GstCaps*              : Read / Write

force caps without doing a typefind.

### The `"minimum"` property

      "minimum"                  guint                 : Read / Write

minimum probability required to accept caps.

Allowed values: [1,100]

Default value: 1

## Signal Details

### The `"have-type"` signal

    void                user_function                      (GstTypeFindElement *typefind,
                                                            guint               probability,
                                                            GstCaps            *caps,
                                                            gpointer            user_data)        : Run First

This signal gets emitted when the type and its probability has been found.

`typefind` : | the typefind instance
`probability` : | the probability of the type found
`caps` : | the caps of the type found
`user_data` : | user data set when the signal handler was connected.